#pragma once

#ifndef SPCIDEV_H
#define SPCIDEV_H

int _cdecl OpenDevice(int DevIndex);
int _cdecl CloseDevice(int DevIndex);

int _cdecl GetDeviceModel(int DevIndex, unsigned long *Model);
int _cdecl GetDeviceSN(int DevIndex, unsigned long *SN);

int _cdecl ReadDevice(int DevIndex, unsigned long OffsetAddress, unsigned long *Value);
int _cdecl WriteDevice(int DevIndex, unsigned long OffsetAddress, unsigned long Value);
int _cdecl GetDriverFifoUsedw(int DevIndex, unsigned long *DriverFifoUsedw);

//--------------------------------------------------------------------------
// analog input function
int _cdecl AiReady(int DevIndex, unsigned long ReadyOrNot);
int _cdecl SetAiConnectType(int DevIndex, unsigned long AiConnectType);
int _cdecl SetAiChannelSellect(int DevIndex, unsigned long AiChannelSellect);
int _cdecl SetAiSampleMode(int DevIndex, unsigned long AiSampleMode);
int _cdecl SetAiRange(int DevIndex, unsigned long AiRange, unsigned long AiChannel);
int _cdecl SetAiSamplePeriod(int DevIndex, unsigned long AiSamplePeriod);
int _cdecl SetAiOneShotCount(int DevIndex, unsigned long AiOneShotCount);
int _cdecl SetAiTrigSource(int DevIndex, unsigned long AiTrigSource);
int _cdecl GetAiOnePoint(int DevIndex, unsigned long AiChannel, float *AiValue);
int _cdecl GetAiData(int DevIndex, unsigned long Points, float *AiValue, unsigned long *AiFifoUsdw, long Timeout);
int _cdecl ClearAiFifo(int DevIndex);

//--------------------------------------------------------------------------
// analog output function
int _cdecl AoReady(int DevIndex, unsigned long AoChannel, unsigned long ReadyOrNot);
int _cdecl SetAoMode(int DevIndex, unsigned long AoChannel, unsigned long AoMode);
int _cdecl SetAoSamplePeriod(int DevIndex, unsigned long AoChannel, unsigned long AoSamplePeriod);
int _cdecl SetAoNCycleCount(int DevIndex, unsigned long AoChannel, unsigned long AoNCycleCount);
int _cdecl SetAoTrigSource(int DevIndex, unsigned long AoChannel, unsigned long AoTrigSource);
int _cdecl SetAoValue(int DevIndex, unsigned long AoChannel, float AoValue);
int _cdecl SetAoPowerOnValue(int DevIndex, unsigned long AoChannel, float AoPowerOnValue);
int _cdecl SetAoFifo(int DevIndex, unsigned long AoChannel, float AoWaveData);
int _cdecl ClearAoFifo(int DevIndex, unsigned long AoChannel);

//--------------------------------------------------------------------------
// digital input function
int _cdecl DiReady(int DevIndex, unsigned long ReadyOrNot);
int _cdecl SetDiSampleMode(int DevIndex, unsigned long DiSampleMode);
int _cdecl SetDiSamplePeriod(int DevIndex, unsigned long DiSamplePeriod);
int _cdecl SetDiOneShotCount(int DevIndex, unsigned long DiOneShotCount);
int _cdecl SetDiTrigSource(int DevIndex, unsigned long DiTrigSource);
int _cdecl GetDiStatus(int DevIndex, unsigned long Part, unsigned long *DiValue);
int _cdecl GetDiData(int DevIndex, unsigned long Points, unsigned long *DiValue, unsigned long *DiFifoUsdw, long Timeout);
int _cdecl ClearDiFifo(int DevIndex);
int _cdecl SetDiIntLevel(int DevIndex, unsigned long DiIntLevel);
int _cdecl SetDiIntSource(int DevIndex, unsigned long DiIntSource);

int _cdecl SetDiIntEn(int DevIndex, unsigned long DiIntEn);

int _cdecl SetDiSensitivity(int DevIndex, unsigned long DiSensitivity);
int _cdecl SetDiCountEn(int DevIndex, unsigned long DiCountEn);
int _cdecl SetDiCountEdge(int DevIndex, unsigned long DiCountEdge);
int _cdecl GetDiCountValue(int DevIndex, unsigned long DiChan, unsigned long *DiCountValue);
int _cdecl ClearDiCountValue(int DevIndex, unsigned long DiChan);

//--------------------------------------------------------------------------
// digital output function
int _cdecl DoReady(int DevIndex, unsigned long ReadyOrNot);
int _cdecl SetDoMode(int DevIndex, unsigned long DoMode);
int _cdecl SetDoSamplePeriod(int DevIndex, unsigned long DoSamplePeriod);
int _cdecl SetDoNCycleCount(int DevIndex, unsigned long DoNCycleCount);
int _cdecl SetDoTrigSource(int DevIndex, unsigned long DoTrigSource);
int _cdecl SetDoValue(int DevIndex, unsigned long DoValue);
int _cdecl SetDoPowerOnValue(int DevIndex, unsigned long DoPowerOnValue);
int _cdecl SetDoFifo(int DevIndex, unsigned long DoWaveData);
int _cdecl ClearDoFifo(int DevIndex);

//--------------------------------------------------------------------------
// trig system function
int _cdecl SetAiSoftTrig(int DevIndex);
int _cdecl SetDiSoftTrig(int DevIndex);
int _cdecl SetAoSoftTrig(int DevIndex, unsigned long AoChannel);
int _cdecl SetDoSoftTrig(int DevIndex);
int _cdecl SetExtTrigInEdge(int DevIndex, unsigned long TrigEdge);
int _cdecl ClearAiSoftTrig(int DevIndex);
int _cdecl ClearDiSoftTrig(int DevIndex);
int _cdecl ClearAoSoftTrig(int DevIndex, unsigned long AoChannel);
int _cdecl ClearDoSoftTrig(int DevIndex);
int _cdecl ClearExtTrig(int DevIndex);

//--------------------------------------------------------------------------
// sync function
int _cdecl SetClockSource(int DevIndex, unsigned long ClockSource);
int _cdecl SetSyncClkDir(int DevIndex, unsigned long Direction);
int _cdecl SetUserIsr(int DevIndex, void *fun);
int _cdecl SetDioDir(int DevIndex, unsigned long DioDir);
int _cdecl SetDioDirDefault(int DevIndex, unsigned long DioDirDefault);

//--------------------------------------------------------------------------
// calibrate
int _cdecl GotoCalibrate(int DevIndex);

//--------------------------------------------------------------------------
// error code
const int NO_DEVICE = -1;
const int DEVICE_NOT_OPENED = -2;
const int READ_FAILED = -3;
const int WRITE_FAILED = -4;
const int ERROR_DEVICE_MODEL = -5;
const int DI_DATA_MISSED = -6;
const int TIME_OUT = -7;
const int USERISR_RUNNING = -8;
const int UNDEFINED_SAMPLE_PERIOD = -9;

#endif
